;*****WINDOW MESSAGES***********************************************************
CREATE_WM:
 MCBTM EQU <ESP.WINCB.tm>

 INVOKE GetDC,ESI

 LEA ECX,[ESP.WINCB.tm]
 MOV EDI,EAX

 INVOKE GetTextMetricsA,EDI,ECX

 MOV EAX,[MCBTM.tmAveCharWidth]
 MOV [cxChar],EAX
 MOV ECX,[MCBTM.tmExternalLeading]

 TEST [MCBTM.tmPitchAndFamily],1
 .IF !ZERO?            ;if variable font
   LEA EAX,[EAX+2*EAX] ;multiple by 3 if variable font
   SHR EAX,1           ;divide by 2 if variable font
 .ENDIF

 ADD ECX,[MCBTM.tmHeight]
 MOV [cxCaps],EAX      ;cxChar was multiplied by 1 or 1
 MOV [cyChar],ECX

 INVOKE ReleaseDC,ESI,EDI
                     ;save the sum width of the three columns
 MOV EAX,[cxCaps]
 MOV EDX,[cxChar]
 ADD EAX,EAX         ;EAX = cxCaps*2
 SHL EDX,3           ;EDX = cxChar*8
 LEA ECX,[EAX+2*EAX] ;ECX = cxCaps*6
 LEA EDX,[EDX+4*EDX] ;EDX = cxChar*40
 LEA EAX,[ECX+8*EAX] ;EAX = cxCaps*22
 MOV [iMaxWidth],EDX
 ADD [iMaxWidth],EAX ;iMaxWidth = cxChar*40+cxCaps*22
                     ;fall through for mouse wheel information
;-------------------------------------------------------------------------------
SETTINGCHANGE_WM:
  LEA ECX,[ESP.WINCB.ulScrollLines]
  INVOKE SystemParametersInfoA,SPI_GETWHEELSCROLLLINES,EBP,ECX,EBP
                     ;ulScrollLines usually equals 3 or 0 (for no scrolling)
                     ;WHEEL_DELTA equals 120, so iDeltaPerLine will be 40
 .IF [ESP.WINCB.ulScrollLines]!=EBP
   XOR EDX,EDX
   MOV EAX,WHEEL_DELTA
   DIV [ESP.WINCB.ulScrollLines]
   MOV [iDeltaPerLine],EAX ;iDeltaPerLine = 40 for 3 lines per click
                           ;iDeltaPerLine = 60 for 2 lines per click
                           ;iDeltaPerLine = 120 for 1 click per line
                           ;iDeltaPerLine = 240 for 2 clicks  per line
   JMP RETURNZ
 .ENDIF

  MOV [iDeltaPerLine],EBP

RETURNZ:
 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
SIZE_WM:
WCBSI EQU ESP.WINCB.sinfo
                         ;obtain window size in pixels
 MOVZX EAX,DX            ;EDX=lparam
 MOV [cxClient],EAX      ;LOWORD (lParam)
 SHR EDX,16
 MOV [cyClient],EDX      ;HIWORD (lParam)

                         ;set vertical scroll bar range and page size
 XOR EDX,EDX
 MOV [WCBSI.cbSize],SCROLLINFO
 MOV EAX,[cyClient]
 MOV [WCBSI.fMask],SIF_RANGE OR SIF_PAGE
 DIV [cyChar]
 MOV [WCBSI.nMin],EBP
 MOV [WCBSI.nMax],NUMLINES-1
 MOV [WCBSI.nPage],EAX
 LEA ECX,[WCBSI]
 INVOKE SetScrollInfo,ESI,SB_VERT,ECX,ESP ;ESP<>0=TRUE

                         ;set horizontal scroll bar range and page size
 MOV [WCBSI.cbSize],SCROLLINFO
 MOV [WCBSI.fMask],SIF_RANGE OR SIF_PAGE
 MOV [WCBSI.nMin],EBP
 MOV EAX,[iMaxWidth]
 XOR EDX,EDX
 DIV [cxChar]
 ADD EAX,2
 MOV [WCBSI.nMax],EAX
 XOR EDX,EDX
 MOV EAX,[cxClient]
 DIV [cxChar]
 LEA ECX,[WCBSI]
 MOV [WCBSI.nPage],EAX
 INVOKE SetScrollInfo,ESI,SB_HORZ,ECX,ESP ;ESP<>0=TRUE

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
VSCROLL_WM:

 .DATA

SJTAT2 LABEL DWORD       ;start of address table
 DWORD LINEUP_SB         ;table entry
 DWORD LINEDOWN_SB       ;table entry
 DWORD PAGEUP_SB         ;table entry
 DWORD PAGEDOWN_SB       ;table entry
 DWORD RETURNZ           ;VTHUMBPOSITION_SB table entry
 DWORD VTHUMBTRACK_SB ;  ;table entry
 DWORD TOP_SB            ;table entry
 DWORD BOTTOM_SB         ;table entry
 DWORD RETURNZ           ;ENDSCROLL_SBV table entry

 .CODE
                         ;get the current vertical scroll bar position
 MOV [WCBSI.cbSize],SCROLLINFO
 LEA ECX,[WCBSI]
 MOV [WCBSI.fMask],SIF_POS OR SIF_TRACKPOS OR SIF_PAGE
 INVOKE GetScrollInfo,ESI,SB_VERT,ECX
 MOV EAX,[WCBSI.nPos]    ;save the position for comparison later on
 MOV [ESP.WINCB.iVertPos],EAX

 MOVZX EAX,BX            ;LOWORD(wParam)
 SUB EAX,SB_LINEUP
 JMP [SJTAT2+DWORD*EAX]

;*****SCREEN MESSAGES***********************************************************
TOP_SB:
 MOV EAX,[WCBSI.nMin]
 MOV [WCBSI.nPos],EAX
 JMP VSBREAKER
BOTTOM_SB:
 MOV EAX,[WCBSI.nMax]
 MOV [WCBSI.nPos],EAX
 JMP VSBREAKER
LINEUP_SB:
 DEC [WCBSI.nPos]
 JMP VSBREAKER
LINEDOWN_SB:
 INC [WCBSI.nPos]
 JMP VSBREAKER
PAGEUP_SB:
 MOV EAX,[WCBSI.nPage]
 SUB [WCBSI.nPos],EAX
 JMP VSBREAKER
PAGEDOWN_SB:
 MOV EAX,[WCBSI.nPage]
 ADD [WCBSI.nPos],EAX
 JMP VSBREAKER
VTHUMBTRACK_SB:
VTHUMBPOSITION_SB:
 MOV EAX,[WCBSI.nTrackPos]
 MOV [WCBSI.nPos],EAX

                     ;Set the position and then retrieve it. Due to adjustments
                     ;by windows, it might not be the same as the value set.
VSBREAKER:
 LEA ECX,[WCBSI]
 MOV [WCBSI.fMask],SIF_POS
 INVOKIT SetScrollInfo,ESI,SB_VERT,ECX,ESP,ECX ;***push extra ECX for next GetScrollInfo
 INVOKIT GetScrollInfo,ESI,SB_VERT             ;***SCROLLINFO address pushed previously

                     ;if the position has changed, scroll the window and update it
 MOV EAX,[ESP.WINCB.iVertPos]
 SUB EAX,[WCBSI.nPos]
 MUL [cyChar]        ;EAX=cyChar*(iVertPos-sif_nPos)
 INVOKE ScrollWindow,ESI,EBP,EAX,EBP,EBP

 XOR EAX,EAX
 JMP MAINCBRET

;*****END SCREEN MESSAGES*******************************************************
;-------------------------------------------------------------------------------
HSCROLL_WM:

 .DATA

SJTAT3 LABEL DWORD       ;start of address table
 DWORD LINELEFT_SB       ;table entry
 DWORD LINERIGHT_SB      ;table entry
 DWORD PAGELEFT_SB       ;table entry
 DWORD PAGERIGHT_SB      ;table entry
 DWORD RETURNZ           ;HTHUMBPOSITION_SB table entry
 DWORD HTHUMBTRACK_SB    ;table entry
 DWORD LEFT_SB           ;table entry
 DWORD RIGHT_SB          ;table entry
 DWORD RETURNZ           ;ENDSCROLL_SBH table entry

 .CODE
 MOV [WCBSI.cbSize],SCROLLINFO
 LEA ECX,[WCBSI]
 MOV [WCBSI.fMask],SIF_POS OR SIF_TRACKPOS OR SIF_PAGE
 INVOKE GetScrollInfo,ESI,SB_HORZ,ECX ;get the current horizontal scroll bar information

 MOVZX EAX,BX            ;LOWORD(wParam)
 SUB EAX,SB_LINELEFT
 JMP [SJTAT3+DWORD*EAX]

;*****SCREEN MESSAGES***********************************************************
LINELEFT_SB:
 DEC [WCBSI.nPos]
 JMP HBREAKER
LINERIGHT_SB:
 INC [WCBSI.nPos]
 JMP HBREAKER
PAGELEFT_SB:
 MOV EAX,[WCBSI.nPage]
 SUB [WCBSI.nPos],EAX
 JMP HBREAKER
PAGERIGHT_SB:
 MOV EAX,[WCBSI.nPage]
 ADD [WCBSI.nPos],EAX
 JMP HBREAKER
LEFT_SB:
 MOV EAX,[WCBSI.nMin]
 MOV [WCBSI.nPos],EAX
 JMP HBREAKER
RIGHT_SB:
 MOV EAX,[WCBSI.nMax]
 MOV [WCBSI.nPos],EAX
 JMP HBREAKER
HTHUMBPOSITION_SB:
HTHUMBTRACK_SB:
 MOV EAX,[WCBSI.nTrackPos]
 MOV [WCBSI.nPos],EAX

HBREAKER:
 LEA ECX,[WCBSI]
 MOV [WCBSI.fMask],SIF_POS
 INVOKE SetScrollInfo,ESI,SB_HORZ,ECX,ESP ;ESP<>0=TRUE

 INVOKE InvalidateRect,ESI,EBP,ESP

 XOR EAX,EAX
 JMP MAINCBRET
;*****END SCREEN MESSAGES*******************************************************
;-------------------------------------------------------------------------------
KEYDOWN_WM:
 .DATA

SJTAT4 LABEL DWORD ;start of address table
 DWORD PRIOR_VK    ;table entry
 DWORD NEXT_VK     ;table entry
 DWORD END_VK      ;table entry
 DWORD HOME_VK     ;table entry
 DWORD LEFT_VK     ;table entry
 DWORD UP_VK       ;table entry
 DWORD RIGHT_VK    ;table entry
 DWORD DOWN_VK     ;table entry

 .CODE

 .IF (EBX <= VK_DOWN) && (EBX >= VK_PRIOR)  ;EBX = wParam = virtual key code
   SUB EBX,VK_PRIOR
   JMP [SJTAT4+DWORD*EBX]
 .ENDIF

 JMP DEFWINRET
;*****KEYBOARD MESSAGES*********************************************************
HOME_VK:
 MOV EBX,SB_TOP
 JMP VSCROLL_WM
END_VK:
 MOV EBX,SB_BOTTOM
 JMP VSCROLL_WM
PRIOR_VK:
 MOV EBX,SB_PAGEUP
 JMP VSCROLL_WM
NEXT_VK:
 MOV EBX,SB_PAGEDOWN
 JMP VSCROLL_WM
UP_VK:
 MOV EBX,SB_LINEUP
 JMP VSCROLL_WM
DOWN_VK:
 MOV EBX,SB_LINEDOWN
 JMP VSCROLL_WM
LEFT_VK:
 MOV EBX,SB_LINELEFT
 JMP HSCROLL_WM
RIGHT_VK:
 MOV EBX,SB_LINERIGHT
 JMP HSCROLL_WM
;*****END KEYBOARD MESSAGES*****************************************************
;-------------------------------------------------------------------------------
MOUSEWHEEL_WM:
 CMP [iDeltaPerLine],EBP
 JE DEFWINRET

 SAR EBX,16
 MOV EDI,[iDeltaPerLine]
 ADD [iAccumDelta],EBX

 .WHILE SD[iAccumDelta] >= EDI
   INVOKE SendMessageA,ESI,WM_VSCROLL,SB_LINEUP,EBP
   SUB [iAccumDelta],EDI
 .ENDW

 NEG EDI

 .WHILE SD[iAccumDelta] <= EDI
   INVOKE SendMessageA,ESI,WM_VSCROLL,SB_LINEDOWN,EBP
   SUB [iAccumDelta],EDI
  .ENDW
 JMP RETURNZ
;-------------------------------------------------------------------------------
PAINT_WM:
 INVOKE BeginPaint,ESI,ESP            ;ESP=address of ps
 MOV EDI,EAX                          ;now EDI=device context

                                      ;get vertical scroll bar position
 MOV [WCBSI.cbSize],SCROLLINFO
 LEA ECX,[WCBSI]
 MOV [WCBSI.fMask],SIF_POS
 INVOKIT GetScrollInfo,ESI,SB_VERT,ECX,ECX ;***push extra ECX for next GetScrollInfo

 XOR EDX,EDX                          ;prepare for divide
 MOV EAX,[ESP.WINCB.ps.rcPaint.top+1*DWORD]
 PUSH SB_HORZ                         ;***for next GetScrollInfo
 DIV [cyChar]                         ;EAX = number of lines to rcPaint.top
                                      ;EDX = pixel height of partial line
 PUSH ESI                             ;***for next GetScrollInfo
 NEG EDX                              ;prepare to subtract
 ADD EAX,[WCBSI.nPos+3*DWORD]         ;item position relative from beginning of TEXTBUFFER
 ADD EDX,[ESP.WINCB.ps.rcPaint.top+3*DWORD] ;vertical pixel position
 MOV [ESP.WINCB.y+3*DWORD],EDX
 MUL [TXTLINKLEN]                     ;byte position relative from beginning of TEXTBUFFER
 LEA EBX,[EAX+@ TEXTBUFFER]           ;EBX = byte position within data segment

 XOR EDX,EDX
 MOV EAX,[ESP.WINCB.ps.rcPaint.bottom+3*DWORD]
 SUB EAX,[ESP.WINCB.ps.rcPaint.top+3*DWORD]
 DIV [cyChar]
 MOV EDX,txtlink
 MUL EDX
 LEA ESI,[EAX+1*EBX]
 ADD ESI,[cyChar]
                                      ;get horizontal scroll bar positon
 INVOKIT GetScrollInfo                ;***ESI,SB_HORZ,ECX already pushed previously
                                      ;compute horizontal columns
 MOV EAX,[WCBSI.nPos]
 NEG EAX
 INC EAX
 MUL [cxChar]
 MOV [ESP.WINCB.column1],EAX          ;column one computed
 MOV ECX,EAX
 MOV EAX,22
 MUL [cxCaps]
 ADD ECX,EAX
 MOV [ESP.WINCB.column2],ECX          ;column two computed
 MOV EAX,40
 MUL [cxChar]
 ADD ECX,EAX
 MOV [ESP.WINCB.column3],ECX          ;column three computed

 .IF ESI > (@ TEXTBUFFER + txtlink*NUMLINES)
   MOV ESI,(@ TEXTBUFFER + txtlink*NUMLINES)
 .ENDIF

 .WHILE EBX < ESI
   INVOKE TextOut,EDI,[ESP.WINCB.column1+3*DWORD],[ESP.WINCB.y+2*DWORD],\
                  [EBX.txtlink.SYMNAME],[EBX.txtlink.SYMNAMELEN]

   INVOKIT TextOut,EDI,[ESP.WINCB.column2+3*DWORD],[ESP.WINCB.y+2*DWORD],\
                   [EBX.txtlink.SYMDESC],[EBX.txtlink.SYMDESCLEN]

   LEA EBP,[ESP.WINCB.szBuffer]
   INVOKE SetTextAlign,EDI,TA_RIGHT OR TA_TOP
   INVOKE GetSystemMetrics,[EBX.txtlink.SYMINDEX]
   INVOKE wsprintf,EBP,TEXT('%5d',0),EAX
   INVOKIT TextOut,EDI,[ESP.WINCB.column3+3*DWORD],[ESP.WINCB.y+2*DWORD],EBP,EAX
   INVOKE SetTextAlign,EDI,TA_LEFT OR TA_TOP

   MOV ECX,[cyChar]
   ADD EBX,txtlink
   ADD [ESP.WINCB.y],ECX
 .ENDW

 INVOKIT EndPaint,[ESP.WINCB.WHWD+1*DWORD],ESP ;ESP=ps=paint structure

 XOR EAX,EAX
 JMP MAINCBRET

;-------------------------------------------------------------------------------
DESTROY_WM:
 INVOKE PostQuitMessage,EBP

 XOR EAX,EAX
 JMP MAINCBRET
;*****END OF WINDOW MESSAGES****************************************************
